Index: include/asterisk/module.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/module.h,v
retrieving revision 1.16
diff -u -r1.16 module.h
--- include/asterisk/module.h	16 Jan 2005 22:59:30 -0000	1.16
+++ include/asterisk/module.h	25 May 2005 21:10:16 -0000
@@ -213,8 +213,53 @@
 	res = localusecnt; \
 	ast_mutex_unlock(&localuser_lock); \
 }
-	
-	
+
+/*
+ * modules that export symbols should provide an array
+ *	struct symbol_entry exported_symbols[]
+ * of symbols, with a NULL name on the last entry
+ * Functions should be added with MOD_FUNC(name),
+ * data structures with MOD_DATA(_name).
+ *
+ * Modules that require symbols supplied by other modules should
+ * provide an array
+ *	struct symbol_entry required_symbols[]
+ * of symbols, with a NULL name on the last entry
+ * Functions should be added with MOD_FUNC(name),
+ * data structures with MOD_DATA(_name).
+ *
+ * Typically, the whole interface exported by a module should be
+ * in a single structure named after the module, as follows.
+ * Say the module high level name is 'foo', then we should have
+ * - in include/asterisk/foo.h
+ *	struct foo_interface {
+ *		int (*f1)(int, char *);	-- first function exported
+ *		...			--- other functions
+ *	}
+ * - in the module exporting the interface, e.g. res/res_foo.c
+ *	struct foo_interface foo = {
+ *		MOD_FIELD(f1),			-- field and function name are the same
+ *		METHOD_BASE(foo_, f1),	-- field and function name differ by a prefix
+ *		.f1 = function_name,	-- generic case
+ *	}
+ *
+ * Note that the loader requires that no fields of exported_symbols
+ * are NULL.
+ */
+
+struct module;	/* forward declaration for pointer below */
+struct symbol_entry {
+	const char *name;
+	void *value;
+	int size;
+	struct module *src;	/* source module */
+};
+
+#define	MOD_FUNC(_name) { #_name, _name, sizeof(_name) }
+#define	MOD_DATA(_name) { #_name, &_name, sizeof(_name) }
+#define	MOD_WANT(_name) { #_name, &_name, 0 }	/* for required symbols */
+#define	MOD_FIELD(f)	. ## f = f
+#define	METHOD_BASE(_base, _name)	. ## _name = _base ## _name
 
 #if defined(__cplusplus) || defined(c_plusplus)
 }
Index: include/asterisk/monitor.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/monitor.h,v
retrieving revision 1.4
diff -u -r1.4 monitor.h
--- include/asterisk/monitor.h	21 Apr 2005 06:02:44 -0000	1.4
+++ include/asterisk/monitor.h	25 May 2005 21:10:16 -0000
@@ -21,17 +21,19 @@
 	int (*stop)( struct ast_channel *chan, int need_lock);
 };
 
+struct ast_monitor {
 /* Start monitoring a channel */
-int ast_monitor_start(	struct ast_channel *chan, const char *format_spec,
+int (*start)(	struct ast_channel *chan, const char *format_spec,
 						const char *fname_base, int need_lock );
 
 /* Stop monitoring a channel */
-int ast_monitor_stop( struct ast_channel *chan, int need_lock);
+int (*stop)( struct ast_channel *chan, int need_lock);
 
 /* Change monitoring filename of a channel */
-int ast_monitor_change_fname(	struct ast_channel *chan,
+int (*change_fname)(	struct ast_channel *chan,
 								const char *fname_base, int need_lock );
 
-void ast_monitor_setjoinfiles(struct ast_channel *chan, int turnon);
+void (*setjoinfiles)(struct ast_channel *chan, int turnon);
+};
 
 #endif /* _MONITOR_H */
Index: include/asterisk/utils.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/utils.h,v
retrieving revision 1.31
diff -u -r1.31 utils.h
--- include/asterisk/utils.h	20 May 2005 16:30:13 -0000	1.31
+++ include/asterisk/utils.h	25 May 2005 21:10:16 -0000
@@ -197,10 +197,12 @@
 		(ra)->ptr; \
 	})
 
+#if 0
 #ifdef inet_ntoa
 #undef inet_ntoa
 #endif
 #define inet_ntoa __dont__use__inet_ntoa__use__ast_inet_ntoa__instead__
+#endif
 
 #define AST_STACKSIZE 256 * 1024
 #define ast_pthread_create(a,b,c,d) ast_pthread_create_stack(a,b,c,d,0)
Index: include/asterisk/vmodem.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/vmodem.h,v
retrieving revision 1.19
diff -u -r1.19 vmodem.h
--- include/asterisk/vmodem.h	21 Apr 2005 06:02:44 -0000	1.19
+++ include/asterisk/vmodem.h	25 May 2005 21:10:16 -0000
@@ -142,33 +142,35 @@
 	struct ast_modem_pvt *next;			
 };
 
-
+struct ast_modem {
 /*! Register a modem driver */
 /*! Register a driver */
-extern int ast_register_modem_driver(struct ast_modem_driver *mc);
+int (*register_driver)(struct ast_modem_driver *mc);
 
 /*! Unregisters a modem driver */
 /*! Unregister a driver */
-extern int ast_unregister_modem_driver(struct ast_modem_driver *mc);
+int (*unregister_driver)(struct ast_modem_driver *mc);
 
 /*! Sends command */
 /*! Send the command cmd (length len, or 0 if pure ascii) on modem */
-extern int ast_modem_send(struct ast_modem_pvt *p, char *cmd, int len);
+int (*send)(struct ast_modem_pvt *p, char *cmd, int len);
 
 /*! Waits for result */
 /*! Wait for result to occur.  Return non-zero if times out or error, last
    response is stored in p->response  */
-extern int ast_modem_expect(struct ast_modem_pvt *p,  char *result, int timeout);
+int (*expect)(struct ast_modem_pvt *p,  char *result, int timeout);
 
 /*! Waits for result */
 /*! Wait for result to occur.    response is stored in p->response  */
-extern int ast_modem_read_response(struct ast_modem_pvt *p,  int timeout);
+int (*read_response)(struct ast_modem_pvt *p,  int timeout);
 
 /*! Used to start up the PBX on a RING */
 /*! Used by modem drivers to start up the PBX on a RING */
-extern struct ast_channel *ast_modem_new(struct ast_modem_pvt *i, int state);
+struct ast_channel * (*new)(struct ast_modem_pvt *i, int state);
 
 /*! Trim string of trailing stuff */
 /*! Trim off trailing mess */
-extern void ast_modem_trim(char *s);
+void (*trim)(char *s);
+};
+
 #endif
Index: pbx/pbx_dundi.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx/pbx_dundi.c,v
retrieving revision 1.34
diff -u -r1.34 pbx_dundi.c
--- pbx/pbx_dundi.c	8 May 2005 16:44:25 -0000	1.34
+++ pbx/pbx_dundi.c	25 May 2005 21:10:22 -0000
@@ -56,6 +56,13 @@
 
 #define MAX_PACKET_SIZE 8192
 
+static struct ast_crypto *ast_crypto;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_crypto),
+        { NULL, NULL }
+};
+
+
 extern char ast_config_AST_KEY_DIR[];
 
 static char *tdesc = "Distributed Universal Number Discovery (DUNDi)";
@@ -1289,23 +1296,23 @@
 		build_iv(key);
 		aes_encrypt_key128(key, &peer->us_ecx);
 		aes_decrypt_key128(key, &peer->us_dcx);
-		ekey = ast_key_get(peer->inkey, AST_KEY_PUBLIC);
+		ekey = ast_crypto->ast_key_get(peer->inkey, AST_KEY_PUBLIC);
 		if (!ekey) {
 			ast_log(LOG_NOTICE, "No such key '%s' for creating RSA encrypted shared key for '%s'!\n",
 				peer->inkey, dundi_eid_to_str(eid_str, sizeof(eid_str), &peer->eid));
 			return -1;
 		}
-		skey = ast_key_get(peer->outkey, AST_KEY_PRIVATE);
+		skey = ast_crypto->ast_key_get(peer->outkey, AST_KEY_PRIVATE);
 		if (!skey) {
 			ast_log(LOG_NOTICE, "No such key '%s' for signing RSA encrypted shared key for '%s'!\n",
 				peer->outkey, dundi_eid_to_str(eid_str, sizeof(eid_str), &peer->eid));
 			return -1;
 		}
-		if ((res = ast_encrypt_bin(peer->txenckey, key, sizeof(key), ekey)) != 128) {
+		if ((res = ast_crypto->ast_encrypt_bin(peer->txenckey, key, sizeof(key), ekey)) != 128) {
 			ast_log(LOG_NOTICE, "Whoa, got a weird encrypt size (%d != %d)!\n", res, 128);
 			return -1;
 		}
-		if ((res = ast_sign_bin(skey, peer->txenckey, 128, peer->txenckey + 128))) {
+		if ((res = ast_crypto->ast_sign_bin(skey, peer->txenckey, 128, peer->txenckey + 128))) {
 			ast_log(LOG_NOTICE, "Failed to sign key (%d)!\n", res);
 			return -1;
 		}
@@ -1461,14 +1468,14 @@
 		return 1;
 	}
 	/* Decrypt key */
-	key = ast_key_get(peer->outkey, AST_KEY_PRIVATE);
+	key = ast_crypto->ast_key_get(peer->outkey, AST_KEY_PRIVATE);
 	if (!key) {
 		ast_log(LOG_NOTICE, "Unable to find key '%s' to decode shared key from '%s'\n",
 			peer->outkey, dundi_eid_to_str(eid_str, sizeof(eid_str), &peer->eid));
 		return -1;
 	}
 
-	skey = ast_key_get(peer->inkey, AST_KEY_PUBLIC);
+	skey = ast_crypto->ast_key_get(peer->inkey, AST_KEY_PUBLIC);
 	if (!skey) {
 		ast_log(LOG_NOTICE, "Unable to find key '%s' to verify shared key from '%s'\n",
 			peer->inkey, dundi_eid_to_str(eid_str, sizeof(eid_str), &peer->eid));
@@ -1476,11 +1483,11 @@
 	}
 
 	/* First check signature */
-	res = ast_check_signature_bin(skey, newkey, 128, newsig);
+	res = ast_crypto->ast_check_signature_bin(skey, newkey, 128, newsig);
 	if (res) 
 		return 0;
 
-	res = ast_decrypt_bin(dst, newkey, sizeof(dst), key);
+	res = ast_crypto->ast_decrypt_bin(dst, newkey, sizeof(dst), key);
 	if (res != 16) {
 		if (res >= 0)
 			ast_log(LOG_NOTICE, "Weird, key decoded to the wrong size (%d)\n", res);
Index: res/res_adsi.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_adsi.c,v
retrieving revision 1.13
diff -u -r1.13 res_adsi.c
--- res/res_adsi.c	21 Apr 2005 06:02:44 -0000	1.13
+++ res/res_adsi.c	25 May 2005 21:10:23 -0000
@@ -51,6 +51,15 @@
 
 static int alignment = 0;
 
+/* XXX some forward declarations */
+static int adsi_transmit_message_full(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype, int dowait);
+
+static int adsi_download_connect(unsigned char *buf, unsigned char *service,  unsigned char *fdn, unsigned char *sec, int ver);
+static int adsi_download_disconnect(unsigned char *buf);
+static int adsi_data_mode(unsigned char *buf);
+static int adsi_voice_mode(unsigned char *buf, int when);
+static int adsi_print(struct ast_channel *chan, char **lines, int *aligns, int voice);
+
 static int adsi_generate(unsigned char *buf, int msgtype, char *msg, int msglen, int msgnum, int last, int codec)
 {
 	int sum;
@@ -301,7 +310,7 @@
 	
 }
 
-int adsi_begin_download(struct ast_channel *chan, char *service, char *fdn, char *sec, int version)
+static int adsi_begin_download(struct ast_channel *chan, char *service, char *fdn, char *sec, int version)
 {
 	int bytes;
 	unsigned char buf[256];
@@ -320,7 +329,7 @@
 	return -1;
 }
 
-int adsi_end_download(struct ast_channel *chan)
+static int adsi_end_download(struct ast_channel *chan)
 {
 	int bytes;
 	unsigned char buf[256];
@@ -333,7 +342,7 @@
 	return 0;
 }
 
-int adsi_transmit_message_full(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype, int dowait)
+static int adsi_transmit_message_full(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype, int dowait)
 {
 	unsigned char *msgs[5] = { NULL, NULL, NULL, NULL, NULL };
 	int msglens[5];
@@ -407,7 +416,7 @@
 	return res;
 }
 
-int adsi_transmit_message(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype)
+static int adsi_transmit_message(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype)
 {
 	return adsi_transmit_message_full(chan, msg, msglen, msgtype, 1);
 }
@@ -423,7 +432,7 @@
 	return x;
 }
 
-int adsi_load_soft_key(unsigned char *buf, int key, unsigned char *llabel, unsigned char *slabel, unsigned char *ret, int data)
+static int adsi_load_soft_key(unsigned char *buf, int key, unsigned char *llabel, unsigned char *slabel, unsigned char *ret, int data)
 {
 	int bytes=0;
 
@@ -462,7 +471,7 @@
 	
 }
 
-int adsi_connect_session(unsigned char *buf, unsigned char *fdn, int ver)
+static int adsi_connect_session(unsigned char *buf, unsigned char *fdn, int ver)
 {
 	int bytes=0;
 	int x;
@@ -485,7 +494,7 @@
 
 }
 
-int adsi_download_connect(unsigned char *buf, unsigned char *service,  unsigned char *fdn, unsigned char *sec, int ver)
+static int adsi_download_connect(unsigned char *buf, unsigned char *service,  unsigned char *fdn, unsigned char *sec, int ver)
 {
 	int bytes=0;
 	int x;
@@ -515,7 +524,7 @@
 
 }
 
-int adsi_disconnect_session(unsigned char *buf)
+static int adsi_disconnect_session(unsigned char *buf)
 {
 	int bytes=0;
 
@@ -530,7 +539,7 @@
 
 }
 
-int adsi_query_cpeid(unsigned char *buf)
+static int adsi_query_cpeid(unsigned char *buf)
 {
 	int bytes = 0;
 	buf[bytes++] = ADSI_QUERY_CPEID;
@@ -540,7 +549,7 @@
 	return bytes;
 }
 
-int adsi_query_cpeinfo(unsigned char *buf)
+static int adsi_query_cpeinfo(unsigned char *buf)
 {
 	int bytes = 0;
 	buf[bytes++] = ADSI_QUERY_CONFIG;
@@ -550,7 +559,7 @@
 	return bytes;
 }
 
-int adsi_read_encoded_dtmf(struct ast_channel *chan, unsigned char *buf, int maxlen)
+static int adsi_read_encoded_dtmf(struct ast_channel *chan, unsigned char *buf, int maxlen)
 {
 	int bytes = 0;
 	int res;
@@ -585,7 +594,7 @@
 	return bytes;
 }
 
-int adsi_get_cpeid(struct ast_channel *chan, unsigned char *cpeid, int voice)
+static int adsi_get_cpeid(struct ast_channel *chan, unsigned char *cpeid, int voice)
 {
 	char buf[256];
 	int bytes = 0;
@@ -617,7 +626,7 @@
 	return res;
 }
 
-int adsi_get_cpeinfo(struct ast_channel *chan, int *width, int *height, int *buttons, int voice)
+static int adsi_get_cpeinfo(struct ast_channel *chan, int *width, int *height, int *buttons, int voice)
 {
 	char buf[256];
 	int bytes = 0;
@@ -682,7 +691,7 @@
 	return res;
 }
 
-int adsi_data_mode(unsigned char *buf)
+static int adsi_data_mode(unsigned char *buf)
 {
 	int bytes=0;
 
@@ -697,7 +706,7 @@
 
 }
 
-int adsi_clear_soft_keys(unsigned char *buf)
+static int adsi_clear_soft_keys(unsigned char *buf)
 {
 	int bytes=0;
 
@@ -712,7 +721,7 @@
 
 }
 
-int adsi_clear_screen(unsigned char *buf)
+static int adsi_clear_screen(unsigned char *buf)
 {
 	int bytes=0;
 
@@ -727,7 +736,7 @@
 
 }
 
-int adsi_voice_mode(unsigned char *buf, int when)
+static int adsi_voice_mode(unsigned char *buf, int when)
 {
 	int bytes=0;
 
@@ -744,7 +753,7 @@
 
 }
 
-int adsi_available(struct ast_channel *chan)
+static int adsi_available(struct ast_channel *chan)
 {
 	int cpe = chan->adsicpe & 0xff;
 	if ((cpe == AST_ADSI_AVAILABLE) ||
@@ -753,7 +762,7 @@
 	return 0;
 }
 
-int adsi_download_disconnect(unsigned char *buf)
+static int adsi_download_disconnect(unsigned char *buf)
 {
 	int bytes=0;
 
@@ -768,7 +777,7 @@
 
 }
 
-int adsi_display(unsigned char *buf, int page, int line, int just, int wrap, 
+static int adsi_display(unsigned char *buf, int page, int line, int just, int wrap, 
 		 unsigned char *col1, unsigned char *col2)
 {
 	int bytes=0;
@@ -814,7 +823,7 @@
 
 }
 
-int adsi_input_control(unsigned char *buf, int page, int line, int display, int format, int just)
+static int adsi_input_control(unsigned char *buf, int page, int line, int display, int format, int just)
 {
 	int bytes=0;
 
@@ -837,7 +846,7 @@
 
 }
 
-int adsi_input_format(unsigned char *buf, int num, int dir, int wrap, unsigned char *format1, unsigned char *format2)
+static int adsi_input_format(unsigned char *buf, int num, int dir, int wrap, unsigned char *format1, unsigned char *format2)
 {
 	int bytes = 0;
 
@@ -856,7 +865,7 @@
 	return bytes;
 }
 
-int adsi_set_keys(unsigned char *buf, unsigned char *keys)
+static int adsi_set_keys(unsigned char *buf, unsigned char *keys)
 {
 	int bytes=0;
 	int x;
@@ -871,7 +880,7 @@
 	return bytes;
 }
 
-int adsi_set_line(unsigned char *buf, int page, int line)
+static int adsi_set_line(unsigned char *buf, int page, int line)
 {
 	int bytes=0;
 
@@ -902,7 +911,7 @@
 static int total = 0;
 static int speeds = 0;
 
-int adsi_channel_restore(struct ast_channel *chan)
+static int adsi_channel_restore(struct ast_channel *chan)
 {
 	char dsp[256];
 	int bytes;
@@ -929,7 +938,7 @@
 
 }
 
-int adsi_print(struct ast_channel *chan, char **lines, int *aligns, int voice)
+static int adsi_print(struct ast_channel *chan, char **lines, int *aligns, int voice)
 {
 	char buf[4096];
 	int bytes=0;
@@ -949,7 +958,7 @@
 	return res;
 }
 
-int adsi_load_session(struct ast_channel *chan, unsigned char *app, int ver, int data)
+static int adsi_load_session(struct ast_channel *chan, unsigned char *app, int ver, int data)
 {
 	char dsp[256];
 	int bytes;
@@ -990,7 +999,7 @@
 
 }
 
-int adsi_unload_session(struct ast_channel *chan)
+static int adsi_unload_session(struct ast_channel *chan)
 {
 	char dsp[256];
 	int bytes;
@@ -1124,3 +1133,42 @@
 {
 	return ASTERISK_GPL_KEY;
 }
+
+#define	METHOD(x)	METHOD_BASE(adsi_, x)
+struct adsi_services adsi = {
+	/* METHOD(channel_init), */
+	METHOD(begin_download),
+	METHOD(end_download),
+	METHOD(channel_restore),
+	METHOD(print),
+	METHOD(load_session),
+	METHOD(unload_session),
+	/* METHOD(transmit_messages), */
+	METHOD(transmit_message),
+	METHOD(transmit_message_full),
+	METHOD(read_encoded_dtmf),
+	METHOD(connect_session),
+	METHOD(query_cpeid),
+	METHOD(query_cpeinfo),
+	METHOD(get_cpeid),
+	METHOD(get_cpeinfo),
+	METHOD(download_connect),
+	METHOD(disconnect_session),
+	METHOD(download_disconnect),
+	METHOD(data_mode),
+	METHOD(clear_soft_keys),
+	METHOD(clear_screen),
+	METHOD(voice_mode),
+	METHOD(available),
+	METHOD(display),
+	METHOD(set_line),
+	METHOD(load_soft_key),
+	METHOD(set_keys),
+	METHOD(input_control),
+	METHOD(input_format),
+};
+
+struct symbol_entry exported_symbols[] = {
+	MOD_DATA(adsi),
+	{ NULL, NULL }
+};
Index: res/res_crypto.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_crypto.c,v
retrieving revision 1.20
diff -u -r1.20 res_crypto.c
--- res/res_crypto.c	21 Apr 2005 06:02:44 -0000	1.20
+++ res/res_crypto.c	25 May 2005 21:10:24 -0000
@@ -115,7 +115,7 @@
 	return -1;
 }
 
-struct ast_key *ast_key_get(char *kname, int ktype)
+static struct ast_key *ast_key_get(char *kname, int ktype)
 {
 	struct ast_key *key;
 	ast_mutex_lock(&keylock);
@@ -300,7 +300,7 @@
 
 #endif
 
-int ast_sign_bin(struct ast_key *key, char *msg, int msglen, unsigned char *dsig)
+static int ast_sign_bin(struct ast_key *key, char *msg, int msglen, unsigned char *dsig)
 {
 	unsigned char digest[20];
 	int siglen = 128;
@@ -331,7 +331,7 @@
 	
 }
 
-extern int ast_decrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key)
+static int ast_decrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key)
 {
 	int res;
 	int pos = 0;
@@ -357,7 +357,7 @@
 	return pos;
 }
 
-extern int ast_encrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key)
+static int ast_encrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key)
 {
 	int res;
 	int bytes;
@@ -385,7 +385,7 @@
 	return pos;
 }
 
-int ast_sign(struct ast_key *key, char *msg, char *sig)
+static int ast_sign(struct ast_key *key, char *msg, char *sig)
 {
 	unsigned char dsig[128];
 	int siglen = sizeof(dsig);
@@ -398,7 +398,7 @@
 	
 }
 
-int ast_check_signature_bin(struct ast_key *key, char *msg, int msglen, unsigned char *dsig)
+static int ast_check_signature_bin(struct ast_key *key, char *msg, int msglen, unsigned char *dsig)
 {
 	unsigned char digest[20];
 	int res;
@@ -424,7 +424,7 @@
 	return 0;
 }
 
-int ast_check_signature(struct ast_key *key, char *msg, char *sig)
+static int ast_check_signature(struct ast_key *key, char *msg, char *sig)
 {
 	unsigned char dsig[128];
 	int res;
@@ -594,3 +594,19 @@
 {
 	return ASTERISK_GPL_KEY;
 }
+
+static struct ast_crypto ast_crypto = {
+	MOD_FIELD(ast_key_get),
+	/* MOD_FIELD(ast_key_init), */
+	MOD_FIELD(ast_check_signature),
+	MOD_FIELD(ast_check_signature_bin),
+	MOD_FIELD(ast_sign),
+	MOD_FIELD(ast_sign_bin),
+	MOD_FIELD(ast_encrypt_bin),
+	MOD_FIELD(ast_decrypt_bin),
+};
+
+struct symbol_entry exported_symbols[] = {
+	MOD_DATA(ast_crypto),
+	{ NULL, NULL }
+};
Index: res/res_features.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_features.c,v
retrieving revision 1.54
diff -u -r1.54 res_features.c
--- res/res_features.c	16 May 2005 00:43:16 -0000	1.54
+++ res/res_features.c	25 May 2005 21:10:26 -0000
@@ -130,6 +130,17 @@
 	struct parkeduser *next;
 };
 
+static struct adsi_services *adsi;
+static struct ast_monitor *ast_monitor;
+struct symbol_entry required_symbols[] = {
+	MOD_WANT(adsi),
+	MOD_WANT(ast_monitor),
+	{ NULL, NULL }
+};
+
+/* XXX forward declarations */
+static int ast_bridge_call(struct ast_channel *chan,struct ast_channel *peer,struct ast_bridge_config *config);
+
 static struct parkeduser *parkinglot;
 
 AST_MUTEX_DEFINE_STATIC(parking_lock);
@@ -140,12 +151,12 @@
 
 LOCAL_USER_DECL;
 
-char *ast_parking_ext(void)
+static char *ast_parking_ext(void)
 {
 	return parking_ext;
 }
 
-char *ast_pickup_ext(void)
+static char *ast_pickup_ext(void)
 {
 	return pickup_ext;
 }
@@ -241,14 +252,14 @@
 
 	snprintf(tmp, sizeof(tmp), "Parked on %d", parkingnum);
 	message[0] = tmp;
-	res = adsi_load_session(chan, NULL, 0, 1);
+	res = adsi->load_session(chan, NULL, 0, 1);
 	if (res == -1) {
 		return res;
 	}
-	return adsi_print(chan, message, justify, 1);
+	return adsi->print(chan, message, justify, 1);
 }
 
-int ast_park_call(struct ast_channel *chan, struct ast_channel *peer, int timeout, int *extout)
+static int ast_park_call(struct ast_channel *chan, struct ast_channel *peer, int timeout, int *extout)
 {
 	/* We put the user in the parking list, then wake up the parking thread to be sure it looks
 	   after these channels too */
@@ -334,11 +345,11 @@
                                 );
 
 			if (peer) {
-				if (adsipark && adsi_available(peer)) {
+				if (adsipark && adsi->available(peer)) {
 					adsi_announce_park(peer, pu->parkingnum);
 				}
-				if (adsipark && adsi_available(peer)) {
-					adsi_unload_session(peer);
+				if (adsipark && adsi->available(peer)) {
+					adsi->unload_session(peer);
 				}
 			}
 			con = ast_context_find(parking_con);
@@ -373,7 +384,7 @@
 	return 0;
 }
 
-int ast_masq_park_call(struct ast_channel *rchan, struct ast_channel *peer, int timeout, int *extout)
+static int ast_masq_park_call(struct ast_channel *rchan, struct ast_channel *peer, int timeout, int *extout)
 {
 	struct ast_channel *chan;
 	struct ast_frame *f;
@@ -460,7 +471,7 @@
 	if (callee_chan->monitor) {
 		if (option_verbose > 3)
 			ast_verbose(VERBOSE_PREFIX_3 "User hit '%s' to stop recording call.\n", code);
-		ast_monitor_stop(callee_chan, 1);
+		ast_monitor->stop(callee_chan, 1);
 		return FEATURE_RETURN_SUCCESS;
 	}
 
@@ -909,7 +920,7 @@
 	}
 }
 
-int ast_bridge_call(struct ast_channel *chan,struct ast_channel *peer,struct ast_bridge_config *config)
+static int ast_bridge_call(struct ast_channel *chan,struct ast_channel *peer,struct ast_bridge_config *config)
 {
 	/* Copy voice back and forth between the two channels.  Give the peer
 	   the ability to transfer calls with '#<extension' syntax. */
@@ -1645,6 +1656,7 @@
 int load_module(void)
 {
 	int res;
+
 	if ((res = load_config()))
 		return res;
 	ast_cli_register(&showparked);
@@ -1659,7 +1671,7 @@
 	return res;
 }
 
-int ast_pickup_call(struct ast_channel *chan)
+static int ast_pickup_call(struct ast_channel *chan)
 {
 	struct ast_channel *cur;
 	int res = -1;
@@ -1728,3 +1740,17 @@
 {
 	return ASTERISK_GPL_KEY;
 }
+
+struct ast_features ast_features = {
+	MOD_FIELD(ast_park_call),
+	MOD_FIELD(ast_masq_park_call),
+	MOD_FIELD(ast_parking_ext),
+	MOD_FIELD(ast_pickup_ext),
+	MOD_FIELD(ast_bridge_call),
+	MOD_FIELD(ast_pickup_call),
+};
+
+struct symbol_entry exported_symbols[] = {
+	MOD_DATA(ast_features),
+	{NULL, NULL}
+};
Index: res/res_monitor.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_monitor.c,v
retrieving revision 1.33
diff -u -r1.33 res_monitor.c
--- res/res_monitor.c	6 May 2005 07:15:08 -0000	1.33
+++ res/res_monitor.c	25 May 2005 21:10:28 -0000
@@ -25,6 +25,9 @@
 
 AST_MUTEX_DEFINE_STATIC(monitorlock);
 
+/* XXX forward declaration */
+static int ast_monitor_stop(struct ast_channel *chan, int need_lock);
+static void ast_monitor_setjoinfiles(struct ast_channel *chan, int turnon);
 static unsigned long seq = 0;
 
 static char *monitor_synopsis = "Monitor a channel";
@@ -65,7 +68,7 @@
 	"The argument is the new filename base to use for monitoring this channel.\n";
 
 /* Start monitoring a channel */
-int ast_monitor_start(	struct ast_channel *chan, const char *format_spec,
+static int ast_monitor_start(	struct ast_channel *chan, const char *format_spec,
 		const char *fname_base, int need_lock)
 {
 	int res = 0;
@@ -186,7 +189,7 @@
 }
 
 /* Stop monitoring a channel */
-int ast_monitor_stop(struct ast_channel *chan, int need_lock)
+static int ast_monitor_stop(struct ast_channel *chan, int need_lock)
 {
 	char *execute, *execute_args;
 	int delfiles = 0;
@@ -270,7 +273,7 @@
 }
 
 /* Change monitoring filename of a channel */
-int ast_monitor_change_fname(struct ast_channel *chan, const char *fname_base, int need_lock)
+static int ast_monitor_change_fname(struct ast_channel *chan, const char *fname_base, int need_lock)
 {
 	char tmp[256];
 	if ((!fname_base) || (ast_strlen_zero(fname_base))) {
@@ -536,7 +539,7 @@
 	return 0;
 }
 
-void ast_monitor_setjoinfiles(struct ast_channel *chan, int turnon)
+static void ast_monitor_setjoinfiles(struct ast_channel *chan, int turnon)
 {
 	if (chan->monitor)
 		chan->monitor->joinfiles = turnon;
@@ -587,3 +590,16 @@
 {
 	return ASTERISK_GPL_KEY;
 }
+
+#define	METHOD(x)	METHOD_BASE(ast_monitor_, x)
+static struct ast_monitor ast_monitor = {
+	METHOD(start),
+	METHOD(stop),
+	METHOD(change_fname),
+	METHOD(setjoinfiles),
+};
+
+struct symbol_entry exported_symbols[] = {
+	MOD_DATA(ast_monitor),
+	{ NULL, NULL}
+};
